const state = {
    loadingSaleOrders: false,
    saleOrders: [],
    selectedSaleOrder: null
}

const getters = {
    loadingSaleOrders(state) {
        return state.loadingSaleOrders
    },
    saleOrders(state) {
        return state.saleOrders
    },
    selectedSaleOrder(state) {
        return state.selectedSaleOrder
    }
}

const mutations = {
    setLoadingSaleOrders(state, loading) {
        state.loadingSaleOrders = !!loading
    },
    setSaleOrders(state, saleOrders) {
        state.saleOrders = saleOrders
    },
    setSelectedSaleOrder(state, saleOrdeId) {
        if (!saleOrdeId) {
            return
        }

        state.selectedSaleOrder = state.saleOrders.find(s => s.id === saleOrdeId)
    }
}

const actions = {
    initSaleOrders({ commit }, saleOrders) {
        commit('setSaleOrders', saleOrders)
        commit('setLoadingSaleOrders')
    },
    resetSaleOrder({ commit }) {
        commit('setSaleOrders', [])
        commit('setSelectedSaleOrder', null)
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}